import org.json.simple.JSONObject;
import java.util.ArrayList;
import java.util.List;
/**
* Класс описывающий набор аккаунтов связанных с сущностью
*/
class Accounts implements Essence {
   private List<Account> accounts;
   String docID;
   List<String> rowKeys;
   List<String> dbKeys;
   Accounts() {
       accounts = new ArrayList<>();
       docID = null;
       rowKeys = new ArrayList<>();
       dbKeys = new ArrayList<>();
   }
   public String getDocID() {
       return this.docID;
   }
   public void setDocID(String newDocID) {
       this.docID = newDocID;
   }
   public List<String> getRowKeys() {
       return this.rowKeys;
   }
   void TrySetAccount(JSONObject jsonObject, String essenceTo) {
       Account res = new Account();
       try {
           if (res.service == null && jsonObject.containsKey("service")) {
               res.service = jsonObject.get("service").toString();
           }
           if (res.login == null && jsonObject.containsKey("login")) {
               res.login = jsonObject.get("login").toString();
           }
           if (res.id == null && jsonObject.containsKey("id")) {
               res.id = jsonObject.get("id").toString();
           }
       } catch (Exception e) {
           e.printStackTrace();
       }
       res.essenceTo = essenceTo;
       this.accounts.add(res);
   }
   void TrySetAccount(String serviceName, String fieldName, String value, String essenceTo) {
       Account res;
       int lastIndex = this.accounts.size() - 1;
       if (lastIndex != -1 && this.accounts.get(lastIndex).service.equals(serviceName) && !this.accounts.get(lastIndex).isFillField(fieldName)) {
           res = this.accounts.get(lastIndex);
           res.FillField(fieldName, value);
           res.essenceTo = essenceTo;
           this.accounts.set(lastIndex, res);
       } else {
           res = new Account();
           res.service = serviceName;
           res.FillField(fieldName, value);
           res.essenceTo = essenceTo;
           this.accounts.add(res);
       }
   }
   public List<Essence> getAccounts() {
       return (List<Essence>) (List<?>) this.accounts;
   }
   void setRowKeysAndDbKeys() {
       for (Account account : this.accounts) {
           account.rowKeys.addAll(this.rowKeys);
           account.dbKeys.addAll(this.dbKeys);
       }
   }
   public void Merge(Essence a) {
       Accounts accounts = (Accounts) a;
       this.accounts.addAll(accounts.accounts);
   }
   public void removeDublicates() {
       for (int i = 0; i < this.accounts.size(); ++i) {
           Account oneAccount = this.accounts.get(i);
           for (int j = this.accounts.size() - 1; j > i; --j)
               try {
                   if (this.accounts.get(j).equals(oneAccount))
                       this.accounts.remove(j);
               } catch (Exception e) {
                   e.printStackTrace();
               }
       }
   }
   public boolean isEmpty() {
       return (this.accounts.size() == 0);
   }
   public String toString() {
       String prefix = "";
       StringBuilder tmp = new StringBuilder();
       tmp.append("\"accounts\":[");
       for (Account value : this.accounts) {
           tmp.append(prefix);
           prefix = ",";
           tmp.append(value.toString());
       }
       tmp.append("]");
       return tmp.toString();
   }
   public String getCSVtoNeo4j() {
       return null;
   }

   public String getJSONtoPropertiesNeo4j() {
       return null;
   }
}